//
#include <string.h>
#include "btrip.hh"

struct s_btrip {
  long id;
  char *code;
  char *town;
  char *org;
  char *target;
  char *train;
  s_btrip *next;
};

class Btrip_i : public virtual _sk_Btrip {
private:
  s_btrip *head;
public:
  Btrip_i() { head = NULL; };
  virtual ~Btrip_i();
  long getBtrip(long id, char *&code, char *&town, char *&org,
                  char *&target, char *&train);
  long putBtrip(long id, const char *code, const char *town, const char *org,
                  const char *target, const char *train);
  long delBtrip(long id);
};

Btrip_i::~Btrip_i() {
  s_btrip *d, *c;
  for (c = head; head != NULL; ) {
    d = c;
    c = c->next;
    CORBA::string_free(c->code);
    CORBA::string_free(c->town);
    CORBA::string_free(c->org);
    CORBA::string_free(c->target);
    CORBA::string_free(c->train);
    delete d;
  }
}

long
Btrip_i::getBtrip(long id, char *&code, char *&town, char *&org,
                  char *&target, char *&train) {
  s_btrip *c;
  if (id == 0 && head != NULL) {
    c = head;
    code = CORBA::string_dup(c->code);
    town = CORBA::string_dup(c->town);
    org = CORBA::string_dup(c->org);
    target = CORBA::string_dup(c->target);
    train = CORBA::string_dup(c->train);
    return c->id;
  }
  for (c = head; head != NULL; ) {
    if (id == c->id) {
      code = CORBA::string_dup(c->code);
      town = CORBA::string_dup(c->town);
      org = CORBA::string_dup(c->org);
      target = CORBA::string_dup(c->target);
      train = CORBA::string_dup(c->train);
      return c->id;
    }
    c = c->next;
  }
  return 0;
}

long
Btrip_i::putBtrip(long id, const char *code, const char *town, const char *org,
                  const char *target, const char *train) {
  s_btrip *c;
  long newid = 0;
  for (c = head; head != NULL; ) {
    if (newid < c->id)
      newid = c->id;
    if (id == c->id) {
      c->code = CORBA::string_dup(code);
      c->town = CORBA::string_dup(town);
      c->org = CORBA::string_dup(org);
      c->target = CORBA::string_dup(target);
      c->train = CORBA::string_dup(train);
      return c->id;
    }
    c = c->next;
  }
  c = new s_btrip;
  c->id = newid + 1;
  c->code = CORBA::string_dup(code);
  c->town = CORBA::string_dup(town);
  c->org = CORBA::string_dup(org);
  c->target = CORBA::string_dup(target);
  c->train = CORBA::string_dup(train);
  c->next = head;
  head = c;
  return head->id;
}

long
Btrip_i::delBtrip(long id) {
  s_btrip *c;
/*
  for (c = head; head != NULL; ) {
    if (id == c->id) {
      code = CORBA::string_dup(c->code);
      town = CORBA::string_dup(c->town);
      org = CORBA::string_dup(c->org);
      target = CORBA::string_dup(c->target);
      train = CORBA::string_dup(c->train);
      return c->id;
    }
    c = c->next;
  }
*/
  return 0;
}
